ORG 23bbh
CPU 186

%define data_menuboxselectionpaletteindex 1b26h
%define data_00001b24 1b24h
%define data_currentdrawpage 1b22h
%define func_drawglyph 40d7h
%define func_000024dc 24dch
%define data_00001b28 1b28h
%define func_waitframesandtick 5e08h

%define func_0000245d 3e75h

func_000023bb:
  mov dl, byte [data_menuboxselectionpaletteindex] ; palette indices
  mov dh, byte [data_00001b24] ; style flags, glyph width/height
  mov bh, byte [data_currentdrawpage] ; buffer to use
  mov al, byte [byte bp+00h]
  inc bp
  cmp al, 02h
  jz label_0000242a ; byte isn't 2 (1), draw double-byte codes with lookup from start of file
    label_000023cf:
      mov al, byte [byte bp+00h]
      inc bp
      cmp al, 00h
      jnz label_000023da
        jmp near label_0000245c ; break
      label_000023da:
      cmp al, 04h
      jnz label_000023e3 ; new line
        call near func_000024dc
        jmp short label_000023cf ; continue
      label_000023e3:
      cmp al, 18h
      jc label_000023fb ; if ((unsigned)al >= 0x18)
        cmp al, 7fh
        jnbe label_000023ef ; if ((unsigned)al <= 0x7f) // ascii range
          sub al, 17h ; al -= 0x17; // effective range 0x01 - 0x68 (first part of character lookup)
          jmp short label_00002403 ; goto else
        label_000023ef:
        cmp al, 0a0h
        jc label_000023fb
        cmp al, 0dfh
        jnbe label_000023fb ; else if (al >= 0xa0 && al <= 0xdf) // halfwidth katakana
          sub al, 37h ; al -= 0x37; // effective range 0x69 - 0xa8 (latter part of character lookup)
          jmp short label_00002403 ; goto else
      label_000023fb: ; end if
      mov ah, al ; character is first part of uncommon (used once) double-byte
      mov al, byte [byte bp+00h]
      inc bp
      jmp short label_00002412
      label_00002403: ; else, load commonly used character from block at beginning of file
        sub ah, ah
        sal ax, 1
        mov si, ax
        mov ax, word [ss:si]
        ; toggle glyph width if single byte and full-width or double byte and half-width
        xchg ah, al
      label_00002412:
      cmp ah, 1
      sbb cl, cl
      mov ch, dh
      and ch, 0f1h
      cmp ch, dh
      sbb ch, ch
      inc cl
      inc ch
      xor cl, dh
      and cl, ch
      xor dh, cl
      call near func_0000245d ; get bl (byte pos x)
      call near func_drawglyph
      ;testkeystate KS_CTRL ; skip instantly if CTRL key is held (instant text)
      mov ax, 040eh
      int 18h
      test ah, 10h
      jnz label_000023cf
        mov ax, word [data_00001b28] ; number of frames to wait before next character
        call near func_waitframesandtick
      jmp short label_000023cf
  label_0000242a: ; byte is 2, draw only raw single byte codes
  mov dh, byte [data_00001b24]
  and dh, 0f0h ; halfwidth glyphs (8 x 16)
  label_00002431:
    sub ah, ah
    mov al, byte [byte bp+00h]
    inc bp
    cmp al, 00h
    jz label_0000245c ; return
    cmp al, 04h
    jnz label_00002444 ; new line
      call near func_000024dc
      jmp short label_00002431
    label_00002444:
    call near func_0000245d ; get bl (byte pos x)
    call near func_drawglyph
    ;testkeystate KS_CTRL
    mov ax, 040eh
    int 18h
    test ah, 10h
    jnz label_00002431
      mov ax, word [data_00001b28]
      call near func_waitframesandtick
    jmp short label_00002431
label_0000245c:
  retn
